#include <stdio.h>
#include <mpadvise.h>
#include <cpuset.h>
#include <stdlib.h>


main()
{
	cpuset_t* setp;
	cpu_t max,min;
	char *cpustr;
	int ret,cpu;


 	setp = cpuset_alloc();
 	cpuset_init(setp);
	ret = mpadvise (MPA_CPU_PRESENT,0,0,setp);
	if (ret!=MPA_FAILURE)
	{
		cpustr = cpuset_get_string(setp);
		printf("MPA_CPU_PRESENT is \"%s\"\n",cpustr);
		free(cpustr);
	}
	else
	{
		printf("MPA_CPU_PRESENT is error\n");
	}

 	cpuset_init(setp);
	ret = mpadvise (MPA_CPU_ACTIVE,0,0,setp);
	if (ret!=MPA_FAILURE)
	{
		cpustr = cpuset_get_string(setp);
		printf("MPA_CPU_ACTIVE is \"%s\"\n",cpustr);
		free(cpustr);
	}
	else
	{
		printf("MPA_CPU_ACTIVE is error\n");
	}

 	cpuset_init(setp);
	ret = mpadvise (MPA_CPU_BOOT,0,0,setp);
	if (ret!=MPA_FAILURE)
	{
		cpustr = cpuset_get_string(setp);
		printf("MPA_CPU_BOOT is \"%s\"\n",cpustr);
		free(cpustr);
	}
	else
	{
		printf("MPA_CPU_BOOT is error\n");
	}

 	cpuset_init(setp);
	ret = mpadvise (MPA_PRC_GETBIAS,MPA_PID,0,setp);
	if (ret!=MPA_FAILURE)
	{
		cpustr = cpuset_get_string(setp);
		printf("MPA_PRC_GETBIAS is \"%s\"\n",cpustr);
		free(cpustr);
	}
	else
	{
		printf("MPA_PRC_GETBIAS is error\n");
	}

 	cpuset_init(setp);
	ret = mpadvise (MPA_PRC_GETRUN,MPA_PID,0,setp);
	if (ret!=MPA_FAILURE)
	{
		cpustr = cpuset_get_string(setp);
		printf("MPA_PRC_GETRUN is \"%s\"\n",cpustr);
		free(cpustr);
	}
	else
	{
		printf("MPA_PRC_GETRUN is error\n");
	}

 	max = cpuset_max_cpu();
        min = cpuset_min_cpu();
        for(cpu=min;cpu<=max;cpu++)
        {
 		cpuset_init(setp);/* clear */
                cpuset_set_cpu(setp,cpu,1);/* 1:set */
		ret = mpadvise (MPA_PRC_SETBIAS,MPA_PID,0,setp);
		if (ret!=MPA_FAILURE)
		{
			printf("MPA_PRC_SETBIAS %d is SUCCESS\t",cpu);
		}
		else
		{
			printf("MPA_PRC_SETBIAS %d is FAIL\t",cpu);
		}

 		cpuset_init(setp);
		ret = mpadvise (MPA_PRC_GETRUN,MPA_PID,0,setp);
		if (ret!=MPA_FAILURE)
		{
			cpustr = cpuset_get_string(setp);
			printf("MPA_PRC_GETRUN is \"%s\"\n",cpustr);
			free(cpustr);
		}
		else
		{
			printf("MPA_PRC_GETRUN is error\n");
		}


        }
  	cpuset_free(setp);
}
