#define _LARGEFILE64_SOURCE
#include <stdio.h>
#define __USE_GNU
#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <malloc.h>

/*
[root@RehHawk5 contig]# ./rfile 
_PC_ALLOC_SIZE_MIN 4096
allocate 4294967296 bytes
[root@RehHawk5 contig]# ll
合計 440
-rw-r--r-- 1 root sys         408  8月 17 17:30 Makefile
-rw-r--r-- 1 root root 4294967296  8月 18 09:06 realtime_file
-rwxr-xr-x 1 root root       6211  8月 18 09:06 rfile
-rw-r--r-- 1 root sys         897  8月 18 09:06 rfile.c
-rw-r--r-- 1 root root       1800  8月 18 09:06 rfile.o
*/



main()
{
	int fd;
	off64_t align;
	long long bytes;
	char *dummy;

	bytes = 4294967296LL;//0x100000000;

	if ((fd = open64("realtime_file",(O_CREAT|O_WRONLY|O_DIRECT), 0666)) <0)
	//if ((fd = open64("realtime_file",(O_CREAT|O_WRONLY), 0666)) <0)
	{
		exit(1);
	}
	align = (off64_t)fpathconf(fd,_PC_ALLOC_SIZE_MIN);

	printf("_PC_ALLOC_SIZE_MIN %lld\n",align);
	printf("allocate %lld bytes\n",bytes);
	posix_memalign((void*)&dummy,align,0x1000);

	if (posix_fadvise(fd,0LL,bytes,POSIX_FADV_NOREUSE)<0)
	{
		fprintf(stderr,"fadvise error\n");
		exit(0);
	} else {
		if (posix_fallocate64(fd,0LL,bytes)<0)
		{
			fprintf(stderr, "falocate error\n");
			exit(0);
		}
		bytes -= 4096LL;
		if (lseek64(fd,bytes,SEEK_SET)<0)
		{
			fprintf(stderr,"lseek error\n");
		}
		write(fd,dummy,0x1000);
	}
	close(fd);
}

